Annotation of elwix/build_kernel.sh, revision 1.8.4.2

1.1       misho       1: #!/bin/sh
                      2: #
                      3: # ELWIX build script for kernel
                      4: #
                      5: # (C) AITNET ltd - Sofia/Bulgaria <office@aitnet.org>
                      6: #    by Michael Pounov <misho@elwix.org>
                      7: #
1.8.4.2 ! misho       8: # $Id: build_kernel.sh,v 1.8.4.1 2021/08/30 21:41:15 misho Exp $
1.1       misho       9: #
                     10: 
                     11: [ -r ./config/rc.elwix ] && . ./config/rc.elwix
                     12: if [ X"${ELWIX_IS_CONFIGURED}" != X"YES" ]; then
                     13:        echo
                     14:        echo "ELWIX project is not configured !?!"
                     15:        echo
                     16:        exit 1
                     17: fi
                     18: 
                     19: if [ ! -d $BSDSRC -o ! -d ${BSDKERNCONF} ]; then
                     20:        echo
                     21:        echo "ELWIX project is not configured - missing BSD sources !?!"
                     22:        echo
                     23:        exit 1
                     24: fi
                     25: 
                     26: if [ "${USER}" != "root" ]; then
                     27:        echo
                     28:        echo "ELWIX project is not configured - BSD kernel must compile under root !?!"
                     29:        echo
                     30:        exit 1
                     31: fi
                     32: 
                     33: clean_kernel()
                     34: {
1.7       misho      35:        echo "+++ Clean ELWIX Kernel $2 ... $1"
1.4       misho      36:        rm -rf $1
                     37:        mkdir -p $1
1.1       misho      38: 
1.4       misho      39:        ln -sf ${CFGDIR}/$2 ${BSDKERNCONF}
                     40:        ln -sf ${CFGDIR}/${KERNHINT:=$KERNCONF.hints} ${BSDKERNCONF}
1.1       misho      41: }
                     42: 
                     43: build_kernel()
                     44: {
1.7       misho      45:        echo "+++ Build ELWIX Kernel $2 ... $1"
1.1       misho      46:        cd $BSDSRC
                     47:        env MAKEOBJDIRPREFIX=${BSDOBJ} make TARGET=${TARGET} TARGET_ARCH=${TARGET_ARCH} \
1.8.4.1   misho      48:                ${PARALLEL_BUILD} SRCCONF=${SRCCONF} __MAKE_CONF=${MAKECONF} \
1.6       misho      49:                buildkernel KERNCONF=$2
1.3       misho      50:        if [ $? -eq 0 ]; then
                     51:                cd -
                     52:        else
1.2       misho      53:                exit 1
                     54:        fi
1.1       misho      55: }
                     56: 
                     57: install_kernel()
                     58: {
1.7       misho      59:        echo "+++ Install ELWIX Kernel $2 ... $1"
1.1       misho      60:        cd $BSDSRC
                     61:        env MAKEOBJDIRPREFIX=${BSDOBJ} make TARGET=${TARGET} TARGET_ARCH=${TARGET_ARCH} \
1.6       misho      62:                SRCCONF=${SRCCONF} __MAKE_CONF=${MAKECONF} DESTDIR=$1 installkernel KERNCONF=$2
1.1       misho      63:        cd -
                     64: 
1.3       misho      65:        if [ $? -eq 0 ]; then
1.4       misho      66:                echo "ELWIX Platform:${PLATFORM} Version:${VERSION} TargetArch:${TARGET_ARCH}" >$1/elwix.ver
1.3       misho      67:        fi
1.7       misho      68: 
                     69:        echo "+++ Completed ELWIX Kernel $2 ... $1"
1.1       misho      70: }
                     71: 
                     72: ### main()
1.8       misho      73: if [ -n "${1}" ]; then
1.8.4.2 ! misho      74:        case "${1}" in
        !            75:                rootfs)
        !            76:                        rm ${KERN_ROOTFS}/elwix.ver
        !            77:                        ;;
        !            78:                base)
        !            79:                        rm ${KERN}/elwix.ver
        !            80:                        ;;
        !            81:                both)
        !            82:                        rm ${KERN_ROOTFS}/elwix.ver
        !            83:                        rm ${KERN}/elwix.ver
        !            84:                        ;;
        !            85:                *)
        !            86:                        echo "Error:: unknown argument. Please, choose which kind of kernel [base|rootfs|both]?"
        !            87:                        exit 1
        !            88:                        ;;
        !            89:        esac
        !            90: else
        !            91:        echo "Error:: missing argument. Please, choose which kind of kernel [base|rootfs|both]?"
        !            92:        exit 1
1.8       misho      93: fi
                     94: 
1.8.4.2 ! misho      95: if [ "${1}" = "base" -o "${1}" = "both" ]; then
        !            96:        if ! SnitVer ${KERN}/elwix.ver; then
        !            97:                clean_kernel ${KERN} ${KERNCONF}
        !            98:                build_kernel ${KERN} ${KERNCONF}
        !            99:                install_kernel ${KERN} ${KERNCONF}
        !           100:        else
        !           101:                echo "Skipped ELWIX Kernel build ..."
        !           102:        fi
1.1       misho     103: fi
                    104: 
1.8.4.2 ! misho     105: if [ "${1}" = "rootfs" -o "${1}" = "both" ]; then
        !           106:        if ! SnitVer ${KERN_ROOTFS}/elwix.ver; then
        !           107:                clean_kernel ${KERN_ROOTFS} ${KERNCONF_ROOTFS}
        !           108:                build_kernel ${KERN_ROOTFS} ${KERNCONF_ROOTFS}
        !           109:                install_kernel ${KERN_ROOTFS} ${KERNCONF_ROOTFS}
        !           110:        else
        !           111:                echo "Skipped ELWIX rootfs Kernel build ..."
        !           112:        fi
1.4       misho     113: fi
                    114: 
1.8.4.2 ! misho     115: echo "+++ Complete build ELWIX Kernels ${1}"

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>